Opened 2 years ago

Closed 7 months ago

Last modified 4 months ago

#2222 closed Task (fixed)

AGRIF-03_jchanut_vert_coord_interp

Reported by: jamesharle Owned by: jamesharle
Priority: low Milestone: IMMERSE 2020
Component: AGRIF Version: trunk
Severity: minor Keywords: AGRIF,
Cc: Branch review: pending
MP ready?: no Task progress: Development plan for this task is ready. Completion of task AGRIF-01_jchanut_small_jpi_jpj is needed first.

Description (last modified by jchanut)

Action AGRIF-03_jchanut_vert_coord_interp
PI(S) Jérôme Chanut, James Harle

Digest

Developments to nesting (IMMERSE T3.2: Lead Mercator-Ocean , Participants: NERC ) The two-way nesting AGRIF capability will be developed in year 1 to allow each inner nest to use a different vertical coordinate from the model in which it is nested.

Dependencies
Target
Trac Ticket #2222
SVN branch NEMO/branches/2019/dev_r11233_AGRIF-05_jchanut_vert_coord_interp
Previewer(s) Rachid Benshila
Reviewer(s) TBD
Link

'.' => '/nemo/ticket/2222'

Commit History (75)

ChangesetAuthorTimeChangeLog
14568jchanut2021-03-02T15:16:11+01:00

#2222, slight changes to Overflow-agrif test case (only vertical nesting this time). Replaced readme by a pdf with figures. Domaincfg netcdf files to be provided somewhere.

14439jchanut2021-02-11T16:47:07+01:00

#2222, turn on the use of PPR library with vertical nesting

14438jchanut2021-02-11T16:44:50+01:00

#2222, add PPR library compilation

14261jchanut2021-01-05T15:35:39+01:00

#2222, upper bound on bathymetry (relevant in case of s-coordinates only)

14254jchanut2021-01-04T10:44:00+01:00

#2222, DOME test case: for completeness, add online domain definition. input parameters changes

14218jchanut2020-12-18T17:44:52+01:00

#2222, Fixes uninitialized arrays with vertical remap

14217jchanut2020-12-18T17:41:15+01:00

#2222, add link instead of file for xios field definition

14216jchanut2020-12-18T17:39:43+01:00

#2222, Changed DOME expt parameters

14212jchanut2020-12-18T12:19:49+01:00

#2222, update PPR library to circumvent issues found with cpp directives: remove timing instructions. Changed main module extension in .F90 to comply with FCM rules (no effect).

14171jchanut2020-12-14T19:45:09+01:00

#2222, add after field initialization for ssh

14170jchanut2020-12-14T19:43:17+01:00

#2222, 2129: 1) Corrected ssh initialization from parent in line with what has been introduced by Sibylle 2) Fixed bug in dyn interp with expliciit free surface 3) Added check on number of levels in child grid without vertical remapping (must be < jpk_parent) 4) Removed the constrain on initialization from parent only when starting from climatology (requires Euler first step though).

14147jchanut2020-12-10T13:58:47+01:00

#2222, avoid using unitialized array

14125jchanut2020-12-07T20:46:03+01:00

#2222, restore correct ssh initialization from parent grid + suppress useless ice initializations (Clement)

14122jchanut2020-12-07T18:37:04+01:00

#2222, prevent from an out of bound error with AGRIF

14093jchanut2020-12-04T15:07:29+01:00

#2222, and remove ppr from make. back to the black board

14092jchanut2020-12-04T15:05:55+01:00

#2222, remove use of PPR library

14089jchanut2020-12-04T13:19:17+01:00

#2222, forgotten agrif vertical remapping logical in merge

14088jchanut2020-12-04T13:09:25+01:00

#2222, switch on effective use of PPR library

14087jchanut2020-12-04T13:07:40+01:00

#2222, Add compilation of Piecewise Parabolic Reconstruction (PPR) library

14067jchanut2020-12-03T20:21:39+01:00

#2222, restore initialization of ssh for VORTEX to correctly set the vertical grid

14035jchanut2020-12-03T12:18:31+01:00

#2222, remove linear vertical extrapolation over partial cells + correct initial state interp for top

14019jchanut2020-12-02T18:50:19+01:00

#2222, use right thicknesses for initial state interpolation from parent

14001jchanut2020-12-02T15:06:14+01:00

#2222, improve comments for DOME test case

14000jchanut2020-12-02T15:03:17+01:00

#2222, fixes an allocation pb if child initialized from parent (optional)

13961jchanut2020-12-02T00:20:50+01:00

#2222, remove bathy check with AGRIF_DEMO + forgotten change when merging with trunk for ice variables

13952jchanut2020-12-01T19:19:12+01:00

#2222, make new tests namelists compliant with trunk

13944jchanut2020-12-01T17:38:51+01:00

#2222, lost in previous restoring of build tools

13939jchanut2020-12-01T15:34:42+01:00

#2222, bloody externals. Postpone use of PPR library for a while

13937jchanut2020-12-01T13:44:17+01:00

#2222, added:

  • Divergence conserving interpolation for transport (Balsara's scheme)
  • Possibility to shift barotropic interface inside the domain (currently disabled - needed to match volume within sponge)
  • PPR library as default vertical interpolation scheme
  • Trilinear interpolation over partial bottom cells
13936jchanut2020-12-01T13:32:17+01:00

#2222, Add Overflow with embedded zoom (input domain files are required)

13930jchanut2020-11-30T19:07:47+01:00

#2222, add DOME overflow experiment

13926jchanut2020-11-30T16:21:56+01:00

#2222, add Piecewise Polynomial Reconstruction library

13924jchanut2020-11-30T16:04:35+01:00

#2222, fixes linear conservative interpolation - version with limiter currently disabled

13674jchanut2020-10-26T09:48:07+01:00

#2222, suppress update of barotropic corrective fluxes due to asselin filter at first Euler time step. Even better conservation of volume.

13672jchanut2020-10-26T08:13:09+01:00

#2222, add salinity masking in VORTEX test case

13565jchanut2020-10-05T16:18:53+02:00

#2222, 1) Added parent bathymetry volume consistency check 2) Added velocity extrapolation in update 3) Corrected bdy issue #2519

13498jchanut2020-09-21T15:56:43+02:00

#2222 1) Define agrif sponge at f-points 2) Correct bathymetry check with vertical refinement just over needed points

13371jchanut2020-08-03T10:05:48+02:00

#2222, remove constrain on jpk_parent ⇐ jpk_child with last library change

13370jchanut2020-07-31T11:00:33+02:00

#2222, changes to allow less vertical levels over child grid than parent

13352jchanut2020-07-29T10:33:53+02:00

#2222, #2129: correct depths used in linear vertical interpolation. NB: these are also used for initial state interpolation/extrapolation with identical vertical grids

13351jchanut2020-07-28T17:20:03+02:00

#2222, fixes mistakes when removing key_vertical - rename flag in namelist to prevent further mistakes - vertical refinement works fine in VORTEX

13338jchanut2020-07-24T16:29:34+02:00

#2222, forgotten key_agrif in previous commit

13337jchanut2020-07-24T16:01:24+02:00

#2222, start suppressing key_vertical (add ln_vremap namelist flag)

13335jchanut2020-07-22T16:24:10+02:00

Correct definition for tracers as suggested by Laurent, #2222, #2129

13334jchanut2020-07-22T16:20:32+02:00

finish bypassing ocean/ice initialization with AGRIF, #2222, #2129

13313jchanut2020-07-16T18:46:22+02:00

Create branch to finalize vertical interpolation with AGRIF (#2222), transition to new time stepping (#2018) + potential corrections to CMEMS dev (#2129)

12186jchanut2019-12-11T15:18:59+01:00

#2222, remove sponge masking

12152jchanut2019-12-10T15:36:47+01:00

#2222: fixes linear vertical interpolation of viscosities

12151jchanut2019-12-10T15:34:58+01:00

#2222: fixes linear vertical interpolation of viscosities

12123jchanut2019-12-09T13:55:34+01:00

Merge devs from #2199 and #2222 in trunk

12120jchanut2019-12-09T12:03:44+01:00

2019 agrif update: #2199 and #2222

12119jchanut2019-12-09T11:55:22+01:00

#2222, remove useless mask checking (and restrict scale factor check at the boundary only until nesting tools are updated in sponge areas). Take into account special values in tracer updates, again, till nesting tools are updated.

12048jchanut2019-12-04T16:32:38+01:00

#2222, add small tolerance for bathymetry matching test; correct U-V parent bathymetry on child grid in the special case of s coord into s coord

11868jchanut2019-11-06T16:43:51+01:00

#2222, 1) Correct sponge mainly for using AGRIF in 2DV domains, 2) Add check of bathymetry consistency

11827jchanut2019-10-29T16:03:36+01:00

#2222, corrections to interpolation within sponge

11802jchanut2019-10-25T17:15:20+02:00

#2222, 1) add linear interpolation in vremap module. 2) Switch remapping of viscosity from polynomial to linear. 3) Move to truly volume weighted averages for parent to child update.

11791jchanut2019-10-25T10:35:15+02:00

#2222, scalar not initialized outside of conditional statement

11769jchanut2019-10-23T12:08:33+02:00

#2222 1) change sponge definition to add time relaxation in addition to Laplacian diffusion (WRF like): Add new parameters in namelist. 2) Reduce sponge width by 1 child grid point to match coarse grid cells.

11760jchanut2019-10-21T21:17:59+02:00

#2222, mistake in previous commit

11741jchanut2019-10-21T12:26:39+02:00

#2222: correct definition of parent vertical grid on the child domain to perform vertical interpolation at boundaries. Use additionnal parent depths and number of levels arrays interpolated on the child grid domain to do so. Correction of vertical interpolation of viscosity remains to be done as well as duplication of changes for passive tracers.

11740jchanut2019-10-21T10:55:02+02:00

#2222, typo in comment

11739jchanut2019-10-21T10:49:30+02:00

#2222, make possible vertical coordinate change with VORTEX (child vertical grid spacing chosen in namelist) + fix to compile VORTEX without key_AGRIF

11625jchanut2019-10-01T15:18:44+02:00

#2222, add initialization to 0 of tracer open boundary data with vertical interpolation + various neutral optimizations

11610jchanut2019-09-27T14:08:17+02:00

#2222, fixes to enable compiling AGRIF with TOP

11607jchanut2019-09-27T11:59:22+02:00

#2222, remove slight unconsistencies in update with or without key_vertical defined

11605jamesharle2019-09-26T21:23:26+02:00

#2222, tidy _wp for some variables. There are small difference in simulations of the AGRIF_DEMO config with Pacific only nest (same vertical grid) with and without key_vertical.

11603jchanut2019-09-26T17:27:43+02:00

#2222, 1) correct time interpolation of barotropic velocities in corners. 2) Clean remapping module and enable remapping several variables at the same time. At this stage, vertical remapping doesn't change VORTEX results with an identical vertical grid ONLY in one way mode and a linearized free surface (within truncature errors).

11590jchanut2019-09-23T18:25:29+02:00

#2222: 1) create remapping module (vremap) and integration of D. Engwirda piecewise polynomial recontruction package (PPR_LIB cpp key). 2) Various bug corrections with key_vertical activated.

11574jchanut2019-09-19T12:08:31+02:00

#2222, import changes from dev_r10973_AGRIF-01_jchanut_small_jpi_jpj (i.e. #2199)

11573jchanut2019-09-19T11:18:03+02:00

#2222, merged with trunk

11570jchanut2019-09-18T19:51:33+02:00

#2222, delete som external properties

11569jchanut2019-09-18T19:30:13+02:00

#2222, useless branch

11566jchanut2019-09-18T17:16:23+02:00

#2222, Start new developing branch for AGRIF vertical interpolation

11243jchanut2019-07-10T14:19:49+02:00

#2222, correct bug in update with key_vertical

11238jchanut2019-07-10T10:26:07+02:00

#2222 AGRIF vertical grid change - Create branch from trunk

Change History (82)

comment:1 Changed 2 years ago by jchanut

In 11238:

#2222 AGRIF vertical grid change - Create branch from trunk

comment:2 Changed 2 years ago by jchanut

In 11243:

#2222, correct bug in update with key_vertical

comment:3 Changed 22 months ago by jamesharle

  • Description modified (diff)

comment:4 Changed 22 months ago by jchanut

  • Description modified (diff)
  • Task progress set to Development plan for this task is ready. Completion of task AGRIF-01_jchanut_small_jpi_jpj is needed first.

comment:5 Changed 21 months ago by jchanut

In 11566:

#2222, Start new developing branch for AGRIF vertical interpolation

comment:6 Changed 21 months ago by jchanut

In 11569:

#2222, useless branch

comment:7 Changed 21 months ago by jchanut

In 11570:

#2222, delete som external properties

comment:8 Changed 21 months ago by jchanut

In 11573:

#2222, merged with trunk

comment:9 Changed 21 months ago by jchanut

In 11574:

#2222, import changes from dev_r10973_AGRIF-01_jchanut_small_jpi_jpj (i.e. #2199)

comment:10 Changed 21 months ago by jchanut

In 11590:

#2222: 1) create remapping module (vremap) and integration of D. Engwirda piecewise polynomial recontruction package (PPR_LIB cpp key). 2) Various bug corrections with key_vertical activated.

comment:11 Changed 21 months ago by jchanut

In 11603:

#2222, 1) correct time interpolation of barotropic velocities in corners. 2) Clean remapping module and enable remapping several variables at the same time. At this stage, vertical remapping doesn't change VORTEX results with an identical vertical grid ONLY in one way mode and a linearized free surface (within truncature errors).

comment:12 Changed 21 months ago by jamesharle

In 11605:

#2222, tidy _wp for some variables. There are small difference in
simulations of the AGRIF_DEMO config with Pacific only nest (same
vertical grid) with and without key_vertical.

comment:13 Changed 21 months ago by jchanut

In 11607:

#2222, remove slight unconsistencies in update with or without key_vertical defined

comment:14 Changed 21 months ago by jchanut

In 11610:

#2222, fixes to enable compiling AGRIF with TOP

comment:15 Changed 21 months ago by jchanut

In 11625:

#2222, add initialization to 0 of tracer open boundary data with vertical interpolation + various neutral optimizations

comment:16 Changed 20 months ago by jchanut

In 11739:

#2222, make possible vertical coordinate change with VORTEX (child vertical grid spacing chosen in namelist) + fix to compile VORTEX without key_AGRIF

comment:17 Changed 20 months ago by jchanut

In 11740:

#2222, typo in comment

comment:18 Changed 20 months ago by jchanut

In 11741:

#2222: correct definition of parent vertical grid on the child domain to perform vertical interpolation at boundaries. Use additionnal parent depths and number of levels arrays interpolated on the child grid domain to do so.
Correction of vertical interpolation of viscosity remains to be done as well as duplication of changes for passive tracers.

comment:19 Changed 20 months ago by jchanut

In 11760:

#2222, mistake in previous commit

comment:20 Changed 20 months ago by jchanut

In 11769:

#2222 1) change sponge definition to add time relaxation in addition to Laplacian diffusion (WRF like): Add new parameters in namelist.
2) Reduce sponge width by 1 child grid point to match coarse grid cells.

comment:21 Changed 20 months ago by jchanut

In 11791:

#2222, scalar not initialized outside of conditional statement

comment:22 Changed 20 months ago by jchanut

In 11802:

#2222, 1) add linear interpolation in vremap module.
2) Switch remapping of viscosity from polynomial to linear.
3) Move to truly volume weighted averages for parent to child update.

comment:23 Changed 20 months ago by jchanut

In 11827:

#2222, corrections to interpolation within sponge

comment:24 Changed 20 months ago by jchanut

In 11868:

#2222, 1) Correct sponge mainly for using AGRIF in 2DV domains, 2) Add check of bathymetry consistency

comment:25 Changed 19 months ago by jchanut

In 12048:

#2222, add small tolerance for bathymetry matching test; correct U-V parent bathymetry on child grid in the special case of s coord into s coord

comment:26 Changed 19 months ago by jchanut

In 12119:

#2222, remove useless mask checking (and restrict scale factor check at the boundary only until nesting tools are updated in sponge areas). Take into account special values in tracer updates, again, till nesting tools are updated.

comment:27 Changed 19 months ago by jchanut

In 12120:

2019 agrif update: #2199 and #2222

comment:28 Changed 19 months ago by jchanut

In 12123:

Merge devs from #2199 and #2222 in trunk

comment:29 Changed 19 months ago by jchanut

In 12151:

#2222: fixes linear vertical interpolation of viscosities

comment:30 Changed 19 months ago by jchanut

In 12152:

#2222: fixes linear vertical interpolation of viscosities

comment:31 Changed 19 months ago by jchanut

In 12186:

#2222, remove sponge masking

comment:32 Changed 18 months ago by jchanut

  • Milestone changed from IMMERSE 2019 to IMMERSE 2020

comment:33 Changed 18 months ago by jchanut

  • Branch review changed from failed to pending

comment:34 Changed 18 months ago by jchanut

  • Description modified (diff)
  • Summary changed from AGRIF-05_jchanut_vert_coord_interp to AGRIF-03_jchanut_vert_coord_interp

comment:35 Changed 11 months ago by jchanut

In 13313:

Create branch to finalize vertical interpolation with AGRIF (#2222), transition to new time stepping (#2018) + potential corrections to CMEMS dev (#2129)

comment:36 Changed 11 months ago by jchanut

In 13334:

finish bypassing ocean/ice initialization with AGRIF, #2222, #2129

comment:37 Changed 11 months ago by jchanut

In 13335:

Correct definition for tracers as suggested by Laurent, #2222, #2129

comment:38 Changed 11 months ago by jchanut

In 13337:

#2222, start suppressing key_vertical (add ln_vremap namelist flag)

comment:39 Changed 11 months ago by jchanut

In 13338:

#2222, forgotten key_agrif in previous commit

comment:40 Changed 11 months ago by jchanut

In 13351:

#2222, fixes mistakes when removing key_vertical - rename flag in namelist to prevent further mistakes - vertical refinement works fine in VORTEX

comment:41 Changed 11 months ago by jchanut

In 13352:

#2222, #2129: correct depths used in linear vertical interpolation. NB: these are also used for initial state interpolation/extrapolation with identical vertical grids

comment:42 Changed 11 months ago by jchanut

In 13370:

#2222, changes to allow less vertical levels over child grid than parent

comment:43 Changed 11 months ago by jchanut

In 13371:

#2222, remove constrain on jpk_parent ⇐ jpk_child with last library change

comment:44 Changed 9 months ago by jchanut

In 13498:

#2222 1) Define agrif sponge at f-points 2) Correct bathymetry check with vertical refinement just over needed points

comment:45 Changed 9 months ago by jchanut

In 13565:

#2222, 1) Added parent bathymetry volume consistency check 2) Added velocity extrapolation in update 3) Corrected bdy issue #2519

comment:46 Changed 8 months ago by jchanut

In 13672:

#2222, add salinity masking in VORTEX test case

comment:47 Changed 8 months ago by jchanut

In 13674:

#2222, suppress update of barotropic corrective fluxes due to asselin filter at first Euler time step. Even better conservation of volume.

comment:48 Changed 7 months ago by jchanut

In 13924:

#2222, fixes linear conservative interpolation - version with limiter currently disabled

comment:49 Changed 7 months ago by jchanut

In 13926:

#2222, add Piecewise Polynomial Reconstruction library

comment:50 Changed 7 months ago by jchanut

In 13930:

#2222, add DOME overflow experiment

comment:51 Changed 7 months ago by jchanut

In 13936:

#2222, Add Overflow with embedded zoom (input domain files are required)

comment:52 Changed 7 months ago by jchanut

In 13937:

#2222, added:

  • Divergence conserving interpolation for transport (Balsara's scheme)
  • Possibility to shift barotropic interface inside the domain (currently disabled - needed to match volume within sponge)
  • PPR library as default vertical interpolation scheme
  • Trilinear interpolation over partial bottom cells

comment:53 Changed 7 months ago by jchanut

In 13939:

#2222, bloody externals. Postpone use of PPR library for a while

comment:54 Changed 7 months ago by jchanut

In 13944:

#2222, lost in previous restoring of build tools

comment:55 Changed 7 months ago by jchanut

In 13952:

#2222, make new tests namelists compliant with trunk

comment:56 Changed 7 months ago by jchanut

In 13961:

#2222, remove bathy check with AGRIF_DEMO + forgotten change when merging with trunk for ice variables

comment:57 Changed 7 months ago by jchanut

In 14000:

#2222, fixes an allocation pb if child initialized from parent (optional)

comment:58 Changed 7 months ago by jchanut

In 14001:

#2222, improve comments for DOME test case

comment:59 Changed 7 months ago by jchanut

In 14019:

#2222, use right thicknesses for initial state interpolation from parent

comment:60 Changed 7 months ago by jchanut

In 14035:

#2222, remove linear vertical extrapolation over partial cells + correct initial state interp for top

comment:61 Changed 7 months ago by jchanut

In 14067:

#2222, restore initialization of ssh for VORTEX to correctly set the vertical grid

comment:62 Changed 7 months ago by jchanut

In 14087:

#2222, Add compilation of Piecewise Parabolic Reconstruction (PPR) library

comment:63 Changed 7 months ago by jchanut

In 14088:

#2222, switch on effective use of PPR library

comment:64 Changed 7 months ago by jchanut

In 14089:

#2222, forgotten agrif vertical remapping logical in merge

comment:65 Changed 7 months ago by jchanut

In 14092:

#2222, remove use of PPR library

comment:66 Changed 7 months ago by jchanut

In 14093:

#2222, and remove ppr from make. back to the black board

comment:67 Changed 7 months ago by jchanut

  • Resolution set to fixed
  • Status changed from new to closed

comment:68 Changed 7 months ago by jchanut

In 14122:

#2222, prevent from an out of bound error with AGRIF

comment:69 Changed 7 months ago by jchanut

In 14125:

#2222, restore correct ssh initialization from parent grid + suppress useless ice initializations (Clement)

comment:70 Changed 6 months ago by jchanut

In 14147:

#2222, avoid using unitialized array

comment:71 Changed 6 months ago by jchanut

In 14170:

#2222, 2129: 1) Corrected ssh initialization from parent in line with what has been introduced by Sibylle 2) Fixed bug in dyn interp with expliciit free surface 3) Added check on number of levels in child grid without vertical remapping (must be < jpk_parent) 4) Removed the constrain on initialization from parent only when starting from climatology (requires Euler first step though).

comment:72 Changed 6 months ago by jchanut

In 14171:

#2222, add after field initialization for ssh

comment:73 Changed 6 months ago by smasson

[14171] now pass all sette tests with full debug options on X64_IRENE_DEBUG (ifort 19.0.5) and X64_JEANZAY_DEBUG (ifort 19.1.2)

comment:74 Changed 6 months ago by jchanut

In 14212:

#2222, update PPR library to circumvent issues found with cpp directives: remove timing instructions. Changed main module extension in .F90 to comply with FCM rules (no effect).

comment:75 Changed 6 months ago by jchanut

In 14216:

#2222, Changed DOME expt parameters

comment:76 Changed 6 months ago by jchanut

In 14217:

#2222, add link instead of file for xios field definition

comment:77 Changed 6 months ago by jchanut

In 14218:

#2222, Fixes uninitialized arrays with vertical remap

comment:78 Changed 6 months ago by jchanut

In 14254:

#2222, DOME test case: for completeness, add online domain definition. input parameters changes

comment:79 Changed 6 months ago by jchanut

In 14261:

#2222, upper bound on bathymetry (relevant in case of s-coordinates only)

comment:80 Changed 4 months ago by jchanut

In 14438:

#2222, add PPR library compilation

comment:81 Changed 4 months ago by jchanut

In 14439:

#2222, turn on the use of PPR library with vertical nesting

comment:82 Changed 4 months ago by jchanut

In 14568:

#2222, slight changes to Overflow-agrif test case (only vertical nesting this time). Replaced readme by a pdf with figures. Domaincfg netcdf files to be provided somewhere.

Note: See TracTickets for help on using tickets.